//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  LimeGreen

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    EnvelopePeriod  = 15;
extern int    EnvelopeMaShift = 0;
extern int    EnvelopeMaMode  = MODE_EMA;
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation1      = 0.25;
extern double Deviation2      = 0.50;
extern double Deviation3      = 0.75;

//
//
//
//
//

double UpEnv1[];
double DnEnv1[];
double UpEnv2[];
double DnEnv2[];
double UpEnv3[];
double DnEnv3[];
int    timeFrame;

//
//
//
//                    
//

int init()
{
   SetIndexBuffer(0,UpEnv1);  SetIndexShift(0,EnvelopeMaShift);
   SetIndexBuffer(1,DnEnv1);  SetIndexShift(1,EnvelopeMaShift);
   SetIndexBuffer(2,UpEnv2);  SetIndexShift(2,EnvelopeMaShift);
   SetIndexBuffer(3,DnEnv2);  SetIndexShift(2,EnvelopeMaShift);
   SetIndexBuffer(4,UpEnv3);  SetIndexShift(4,EnvelopeMaShift);
   SetIndexBuffer(5,DnEnv3);  SetIndexShift(5,EnvelopeMaShift);
   
   timeFrame = stringToTimeFrame(TimeFrame);
   SetIndexShift(0,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(1,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(2,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(3,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(4,EnvelopeMaShift * timeFrame/Period());  
   SetIndexShift(5,EnvelopeMaShift * timeFrame/Period());  
   
   IndicatorShortName(timeFrameToString(timeFrame)+" envelopes("+EnvelopePeriod+")");
   
   
return(0);
}  
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
         
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      UpEnv1[i]  = (1+Deviation1/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,y);
      DnEnv1[i]  = (1-Deviation1/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,y);
      UpEnv2[i]  = (1+Deviation2/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,y);
      DnEnv2[i]  = (1-Deviation2/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,y);
      UpEnv3[i]  = (1+Deviation3/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,y);
      DnEnv3[i]  = (1-Deviation3/100)*iMA(NULL,timeFrame,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,y);
   }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
 
   

